<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 10/09/2004 *
 * ================                             Last change: 10/31/2004 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : what-list_unconfirmed.php                        *
 * -------------------------------------------------------------------- *
 * Short description : List unconfirmed mail links                      *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Unbest. Mail-Links auflisten                     *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * Needs to be in all Files and every File needs "svn propset           *
 * svn:keywords Date Revision" (autoprobset!) at least!!!!!!            *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2009 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if ((!defined('__SECURITY')) || (!isAdmin())) {
	die();
} // END - if

// Add description as navigation point
addMenuDescription('admin', __FILE__);

if (!isExtensionActive('mailid')) {
	loadTemplate('admin_settings_saved', false, generateExtensionInactiveNotInstalledMessage('mailid'));
	return;
} // END - if

// Don't load the admin_list_unconfirmed template by default
$listed = false;

// List confirmation links from normal or bonus mails
if (isGetRequestElementSet('mid')) {
	// SQL query for mail data
	$sql = "SELECT
	s.id, p.sender, p.subject, p.text, p.url, p.timestamp, s.max_rec
FROM
	`{?_MYSQL_PREFIX?}_pool` AS p
LEFT JOIN
	`{?_MYSQL_PREFIX?}_user_stats` AS s
ON
	p.id=s.pool_id
WHERE
	p.id='".getRequestElement('mid')."'
LIMIT 1";

	// Column, type and id for member's mail
	$col = 'stats_id'; $type = 'NORMAL'; $ID = '-1';

	// Load admin_list_unconfirmed template
	$listed = true; $DATA = getRequestElement('mid'); $LINK = 'mailid';
} elseif ((isGetRequestElementSet('bid')) && (isExtensionActive('bonus'))) {
	// @TODO This constant might be unused? define('__LIST_UNCON_TITLE', getMessage('LIST_UNCONFIRMED_BONUS_LINKS'));

	// SQL query for mail data (both ids are required for compatiblity to above normal mail
	$sql = "SELECT `id`, `id`, `subject`, `text`, `url`, `timestamp`, `mails_sent` FROM `{?_MYSQL_PREFIX?}_bonus` WHERE `id`='".getRequestElement('bid')."' LIMIT 1";

	// Column, type and id for member's mail
	$col = 'bonus_id'; $type = 'BONUS'; $ID = getRequestElement('bid');

	// Load admin_list_unconfirmed template
	$listed = true; $DATA = $ID; $LINK = 'bonusid';
} else {
	// @TODO "Please do not call me directly." Should be rewritten to a nice selection depending on ext-bonus
	loadTemplate('admin_settings_saved', false, getMessage('ADMIN_CALL_NOT_DIRECTLY'));
}

// Shall I display links or not?
if ($listed === true) {
	// Load mail data
	$result_master = SQL_QUERY($sql, __FILE__, __LINE__);

	// Do we have an entry?
	if (SQL_NUMROWS($result_master) == 1) {
		// Mail order / bonus mail found!
		// @TODO Rewrite this to $content = SQL_FETCHARRAY(), look some lines above for two differrent queries
		list($stats_id, $sender, $subj, $text, $url, $stamp, $max) = SQL_FETCHROW($result_master);

		// Transfer data to constants for the template
		if (($stats_id > 0) && ($ID == '-1')) $ID = $stats_id;
		if ($col == 'bonus_id') $sender = '0';

		// Load unconfirmed mail links. Hmmm, this select query is pretty cool
		// but it does only show unconfirmed mail links from existing user
		// accounts. So if you have delete one you did not see those links
		$result = SQL_QUERY_ESC("SELECT
	l.userid, u.status, u.surname, u.family, u.gender, u.email
FROM
	`{?_MYSQL_PREFIX?}_user_links` AS l
LEFT JOIN
	`{?_MYSQL_PREFIX?}_user_data` AS u
ON
	l.userid=u.userid
WHERE
	l.%s='%s' ORDER BY l.userid LIMIT %s",
			array($col, $ID, bigintval($max)),__FILE__, __LINE__);

		// Total number of unconfirmed mails
		$unconfirmed = SQL_NUMROWS($result);

		if ($unconfirmed > 0) {
			// At least one link left to confirm
			$OUT = ''; $SW = 2;
			while ($content = SQL_FETCHARRAY($result)) {
				// Prepare data for the row template
				// @TODO Rewritings: userid->userid
				$content = array(
					'sw'     => $SW,
					'u_link' => generateUserProfileLink($content['userid']),
					'userid' => $content['userid'],
					'link'   => $LINK,
					'id'     => $ID,
					'email'  => "<a href=\"".generateEmailLink($content['email'], 'user_data')."\">".translateGender($content['gender'])." ".$content['surname']." ".$content['family']."</a>",
					'status' => translateUserStatus($content['status']),
				);

				// Load row template and switch colors
				$OUT .= loadTemplate('admin_list_unconfirmed_row', true, $content);
				$SW = 3 - $SW;
			}

			// Render it in our new listing
			$OUT = loadTemplate('admin_list_unconfirmed_list', true, $OUT);

			// Free memory
			SQL_FREERESULT($result);
		} else {
			// All links are confirmed... strange, you shall normally not get a link to this place in this scenario... hmmm.
			$OUT = loadTemplate('admin_settings_saved', true, getMessage('ADMIN_UNCONFIRMED_NO_LINK_LEFT'));
		}

		// Prepare content
		$content = array(
			'sender_link'   => generateUserProfileLink($sender),
			'subject'       => $subj,
			'text'          => $text,
			'url'           => generateFrametesterUrl($url),
			'unconfirmed'   => $unconfirmed,
			'stamp'         => generateDateTime($stamp, 2),
			'rows'          => $OUT
		);

		// Load final template
		loadTemplate('admin_list_unconfirmed', false, $content);
	} elseif (getRequestElement('mid') > 0) {
		// Data in pool or in user_stats not found, so let's find out where data is missing
		$result1 = SQL_QUERY_ESC("SELECT `id` FROM `{?_MYSQL_PREFIX?}_pool` WHERE `id`=%s LIMIT 1",
			array(bigintval($ID)), __FILE__, __LINE__);
		$result2 = SQL_QUERY_ESC("SELECT `id` FROM `{?_MYSQL_PREFIX?}_user_stats` WHERE `pool_id`=%s LIMIT 1",
			array(bigintval($ID)), __FILE__, __LINE__);

		if (SQL_NUMROWS($result1) == 1) {
			// pool table
			loadTemplate('admin_settings_saved', false, sprintf(getMessage('ADMIN_UNCONFIRMED_POOL_MISSING'), $ID));
		} elseif (SQL_NUMROWS($result2) == 1) {
			// user_stats table
			loadTemplate('admin_settings_saved', false, sprintf(getMessage('ADMIN_UNCONFIRMED_STATS_MISSING'), $ID));
		} else {
			// both or link is invalid
			loadTemplate('admin_settings_saved', false, getMessage('ADMIN_UNCONFIRMED_INVALID_LINK'));
		}

		// Free memory
		SQL_FREERESULT($result1);
		SQL_FREERESULT($result2);
	} elseif (isGetRequestElementSet('bid')) {
		// Data in bonus table not found
		loadTemplate('admin_settings_saved', false, getMessage('ADMIN_UNCONFIRMED_INVALID_LINK'));
	}

	// Free result
	SQL_FREERESULT($result_master);
}

//
?>
