<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 10/14/2003 *
 * ===============                              Last change: 04/28/2004 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : what-login.php                                   *
 * -------------------------------------------------------------------- *
 * Short description : Login area (redirects to the real login module)  *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Loginbereich (leitet an das richtige Lgin-Modul  *
 *                     weiter)                                          *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * Needs to be in all Files and every File needs "svn propset           *
 * svn:keywords Date Revision" (autoprobset!) at least!!!!!!            *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2009 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if (!defined('__SECURITY')) {
	die();
}

// Add description as navigation point
addMenuDescription('guest', __FILE__);

if ((!isExtensionActive('user')) && (!isAdmin())) {
	loadTemplate('admin_settings_saved', false, generateExtensionInactiveNotInstalledMessage('user'));
	return;
} // END - if

// Initialize variables
$errorCode = '0';
$userid = false;
$hash = '';
$URL = '';
$add = '';

// Already logged in?
if ((isMemberIdSet()) && (isSessionVariableSet('u_hash'))) {
	// Maybe, then continue with it
	$userid = getMemberId();
} elseif ((isPostRequestElementSet('id')) && (isPostRequestElementSet('password')) && (isFormSent())) {
	// Set userid and crypt password when login data was submitted
	if (isNicknameUsed(postRequestElement('id'))) {
		// Nickname entered
		$userid = SQL_ESCAPE(postRequestElement('id'));
	} else {
		// Direct userid entered
		$userid  = bigintval(postRequestElement('id'));
	}
} elseif (isPostRequestElementSet('new_pass')) {
	// New password requested
	$userid = '0';
	if (isPostRequestElementSet('id')) $userid = bigintval(postRequestElement('id'));
} else {
	// Not logged in
	$userid = '0'; $hash = '';
}

if (isMember()) {
	// Login immidiately...
	$URL = 'modules.php?module=login';
} elseif ((isFormSent()) && ('' . $userid . '' != '' . postRequestElement('id') . '')) {
	// Invalid input (no nickname extension installed but nickname entered)
	$errorCode = getCode('EXTENSION_PROBLEM');
} elseif (isFormSent()) {
	// Try the login (see inc/libs/user_functions.php)
	$URL = doUserLogin(postRequestElement('id'), postRequestElement('password'));
} elseif ((isPostRequestElementSet('new_pass')) && (isset($userid))) {
	// Try the userid/email lookup (see inc/libs/user_functions.php)
	$errorCode = doNewUserPassword(postRequestElement('email'), $userid);
}

// Login problems?
if (isGetRequestElementSet('login')) {
	// Use code from URL
	$errorCode = getRequestElement('login');
} // END  - if

// No problems, no output by detault
$content['message'] = '';

// Login problems?
if (!empty($errorCode)) {
	// @TODO Move this HTML code into a template
	$message = "<tr>
  <td width=\"10\" class=\"seperator\">&nbsp;</td>
  <td colspan=\"7\" align=\"center\">
    <span class=\"guest_failed\">";

	// Convert the code to message
	$message .= getMessageFromErrorCode($errorCode);

	// Continue with HTML
	$message .= "</span>
  </td>
  <td width=\"10\" class=\"seperator\">&nbsp;</td>
</tr>\n";
	$content['message'] = $message;
} // END - if

// Display login form with resend-password form
if (isExtensionActive('nickname')) {
	loadTemplate('guest_nickname_login', false, $content);
} else {
	loadTemplate('guest_login', false, $content);
}

// Was an URL constructed?
if (!empty($URL)) {
	// URL was constructed
	if (getTotalFatalErrors() > 0) {
		// Handle fatal errors
		runFilterChain('handle_fatal_errors');
	} else {
		// Load URL
		redirectToUrl($URL);
	}
} // END - if

// [EOF]
?>
